:-load_library('alice.tucson.api.Tucson2PLibrary').

:-solve(go(ID)).

go(ID):-	rand_int(9999999,ID),
	rand_int(150,RX), rand_int(150,RY),
	RanX is RX*2, RanY is RY*2,
	rand_int(150,HX), rand_int(150,HY),
	HomX is HX*2, HomY is HY*2,
	go(ID,test_tc,localhost,good,p(150,150),[],cell(home,p(HomX,HomY))).

% go(+ID,+Name,+Node,+Feel,+p(X,Y),+L,+Dest)
% es: go(pippo,test_tc,localhost,good,p(0,0),[],cell(roma,p(10,10))).
go(ID,Name,Node,Feel,p(X,Y),L,Dest):-
	enter_context([agent_id(ID)]),

	update(ID,Name,Node,Feel,oldPos(X,Y),newPos(NX,NY),Dest),
	
	write('New position:'),write([NX,NY]),nl,

	Name @ Node ? out(wantToMove(ID,Feel,p(NX,NY))),
	Name @ Node ? rd(youAre(ID,NFeel,p(TX,TY))),
	
	addCentre(Name,Node,p(TX,TY),L,NL),
	changeDest(p(TX,TY),NL,Dest,NDest),
	write('dest: '),write(NDest),nl,write('------------------------------------------------'),nl,

	go(ID,Name,Node,NFeel,p(TX,TY),NL,NDest).

% update seleziona lo spostamento che si vuole effettuare sulla base
% degli agenti vicini e del centro che si vuole raggiungere.

% update(+ID,+Name,+Node,+Feel,+oldPos(X,Y),-newPos(NX,NY),+cell(C,p(MX,MY)))
% es: update(pippo,test_tc,localhost,good,oldPos(0,0),newPos(NX,NY),cell(roma,p(10,10))).
update(ID,Name,Node,good,oldPos(X,Y),newPos(NX,NY),cell(_,p(MX,MY))):-
	movements(p(X,Y),L),!,clearList(Name,Node,L,NL),!,
	
	write('Safe movements -> '),write(NL),nl,
	
	bestMov(NL,p(X,Y),p(MX,MY),p(NX,NY)),
	write('update salus et best -> ').
		
update(ID,Name,Node,good,oldPos(X,Y),newPos(NX,NY),cell(_,p(MX,MY))):-
	movements(p(X,Y),L),!,bestMov(L,p(X,Y),p(MX,MY),p(NX,NY)),
	write('update unsafe -> ').

update(ID,Name,Node,sick,oldPos(X,Y),newPos(NX,NY),cell(_,p(MX,MY))):-
	movements(p(X,Y),L),!,bestMov(L,p(X,Y),p(MX,MY),p(NX,NY)),
	write('update best -> ').

update(ID,Name,Node,_,oldPos(X,Y),newPos(NX,NY),[]):-
	rand_int(150,RanX), rand_int(150,RanY),
	MX is RanX*2, MY is RanY*2,
	movements(p(X,Y),L),!,bestMov(L,p(X,Y),p(MX,MY),p(NX,NY)),
	write('update random -> ').

% I movimenti possibili sono costretti da una griglia di elementi a
% forma di esagono regolare adiacenti.
% movements(+p(X,Y),-List).
movements(p(X,Y),[p(X1,Y1),p(X2,Y2),p(X3,Y3),p(X4,Y4),p(X5,Y5),p(X6,Y6)]):-
	X1 is X  , Y1 is Y+2,
	X2 is X+1, Y2 is Y+1,
	X3 is X+1, Y3 is Y-1,
	X4 is X  , Y4 is Y-2,
	X5 is X-1, Y5 is Y-1,
	X6 is X-1, Y6 is Y+1.

% ordine della lista di movimenti possibili
% clearList(+Name,+Node,-L,-NL)
clearList(Name,Node,[],[]).
clearList(Name,Node,[p(X,Y)|L],[p(X,Y)|NL]):-
	notSick(Name,Node,p(X,Y)),
	clearList(Name,Node,L,NL).
clearList(Name,Node,[p(X,Y)|L],NL):-
	not notSick(Name,Node,p(X,Y)),
	clearList(Name,Node,L,NL).
	
% Scelta del movimento che avvicina di pi a casa
% Se non ci sono movimenti "safe", meglio rimanere sul posto!
% bestMov(+List,+position,+dest,-movement)
bestMov([],p(X,Y),_,p(X,Y)).
bestMov([p(X,Y)],_,_,p(X,Y)).
bestMov([p(JX,JY),p(KX,KY)|T],p(X,Y),p(MX,MY),p(NX,NY)):-
	X1 is (((MX-JX)*(MX-JX))+((MY-JY)*(MY-JY))),  X2 is (((MX-KX)*(MX-KX))+((MY-KY)*(MY-KY))),
	X1 >= X2,
	bestMov([p(KX,KY)|T],p(X,Y),p(MX,MY),p(NX,NY)).
bestMov([p(JX,JY),p(KX,KY)|T],p(X,Y),p(MX,MY),p(NX,NY)):-
	X1 is (((MX-JX)*(MX-JX))+((MY-JY)*(MY-JY))),  X2 is (((MX-KX)*(MX-KX))+((MY-KY)*(MY-KY))),
	X1 < X2,
	bestMov([p(JX,JY)|T],p(X,Y),p(MX,MY),p(NX,NY)).

% La cella contiene un agente malato?
notSick(Name,Node,p(X,Y)):-
	not Name @ Node ? rdp(youAre(_,sick,p(X,Y))).

% changeDest(+ActualPosition,+ListOfDest's,+cell(C,X),-NewDest)
changeDest(X,L,[],NDest):- select(L,cell(C,X),NDest),!.
changeDest(X,L,cell(C,X),NDest):- select(L,cell(C,X),NDest),!.
changeDest(X,L,D,D).

% Voglio muovermi sempre in direzione di un centro sociale,
% o almeno cercando di avvicinarmi il piu' possibile senza ammalarmi.
% PROBLEMI
addCentre(Name,Node,p(TX,TY),L,[cell(C,p(TX,TY))|L]):-
	Name @ Node ? rdp(cell(C,p(TX,TY))).
addCentre(Name,Node,p(TX,TY),L,L):-
	not Name @ Node ? rdp(cell(C,p(TX,TY))).

% Si sceglie sempre il primo della lista (DA SISTEMARE).	
% select(+L,+H,-D).
select([],H,cell(home,p(HomX,HomY))):-
	rand_int(150,HX), rand_int(150,HY),
	HomX is HX*2, HomY is HY*2.
select([H|T],H,D):-select(T,H,D),!.
select([C|T],H,C).

remove(ID):-
	Name @ Node ? rd(youAre(ID,_,_)),
	exit_context.